---
# Ethernet interface tasks follow #
- name: Manage physical attributes of an ethernet interface
  nxos_interface:
    name: "{{ item.name }}"
    description: "{{ item.description.link_type }}-{{ item.description.building }}-{{ item.description.room }}-{{ item.description.rack }}-{{ item.description.device_type }}-{{ item.description.interface }}"
    mode: "{{ item.mode.layer }}"
    speed: "{{ item.speed }}"
    admin_state: "{{ item.admin_state }}"
    state: "{{ item.state }}"
  when: not item.channel_group.enabled and not item.keepalive and not item.peerlink
  loop: "{{ nw_int_list }}"

- name: Gather interface facts for operation type
  nxos_facts:
    gather_subset: interfaces

- name: Configure an access port
  nxos_l2_interface:
    name: "{{ item.name }}"
    mode: "{{ item.mode.type }}"
    access_vlan: "{{ item.access_vlan }}"
    state: "{{ item.state }}"
  when: not item.channel_group.enabled and not item.keepalive and item.mode.layer == "layer2" and item.mode.type == "access"
  loop: "{{ nw_int_list }}"
- name: Enable BPDUGuard on an access port
  nxos_config:
    lines:
      - spanning-tree bpduguard enable
    parents: "interface {{ item.name }}"
  when: not item.channel_group.enabled and not item.keepalive and item.mode.layer == "layer2" and item.mode.type == "access"
  loop: "{{ nw_int_list }}"
- name: Remove trunk commands
  nxos_config:
    lines:
      - no switchport trunk native vlan
      - no switchport trunk allowed vlan
    parents: "interface {{ item.name }}"
  when: not item.channel_group.enabled and not item.keepalive and item.mode.layer == "layer2" and item.mode.type == "access" and ansible_facts.net_interfaces[item.name].mode == "trunk"
  loop: "{{ nw_int_list }}"

- name: Configure a trunk port
  nxos_l2_interface:
    name: "{{ item.name }}"
    mode: "{{ item.mode.type }}"
    native_vlan: "{{ item.native_vlan }}"
    trunk_allowed_vlans: "{{ item.trunk_allowed_vlans }}"
    state: "{{ item.state }}"
  when: not item.channel_group.enabled and not item.keepalive and item.mode.layer == "layer2" and item.mode.type == "trunk"
  loop: "{{ nw_int_list }}"
- name: Remove BPDUGuard and access vlan from a trunk port
  nxos_config:
    lines:
      - no switchport access vlan
      - no spanning-tree bpduguard enable
    parents: "interface {{ item.name }}"
  when: not item.channel_group.enabled and not item.keepalive and item.mode.layer == "layer2" and item.mode.type == "trunk" and ansible_facts.net_interfaces[item.name].mode == "access"
  loop: "{{ nw_int_list }}"
